#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define SIZE 100                       /* maximal length of file name */

int main(int argc, char **argv)

                                                      /* main program */
                                                          /* ver. 4.1 */
                                                      /* Sep 27, 1999 */
                                                   /* author A. Balaz */
   {
      int help, input, crash, output, example, snap, save;
      int save_relative, mode_N, mode_K, mode_snap;
      long Nrep, iN, iN0, Krep, iK, iK0;
      long rep, irep, irep0, seed, Nsnaprep;
      double N, Nmin, Nstep, K, Kmin, Kstep;
      double Nfac, Nsave, Nsnapmin, Nsnapstep;
      char input_name[SIZE], crash_name[SIZE];
      char example_name[SIZE], output_name[SIZE];
      FILE *input_file, *output_file, *crash_file, *proto_crash;

      void parser(int, char**, int*, int*, char*, int*,
                  char*, int*, char*, int*, char*);

      void print_help(void);
      void create_example(char*);
      void solar_crash(char*, char*);

      void solar(long, long, long, double, double, long*, int, double,
                 int, int, double, double, long, char*);

      parser(argc, argv, &help, &input, input_name, &crash, crash_name,
             &output, output_name, &example, example_name);

      if(help == 1)                                 /* generates help */
         {
            print_help();
            exit(EXIT_SUCCESS);
         }

      if(example == 1)               /* creates example of input file */
         {
            create_example(example_name);
            exit(EXIT_SUCCESS);
         }

      if(output == 0)
         {
            output_name[0] = '\n';
         }

      if(crash == 1)                         /* continues after crash */
         {
            crash_file = fopen(crash_name, "rb");

            fscanf(crash_file,
                   "mode_N=%ld\nNmin=%le\nNstep=%le\nNrep=%ld\n",
                   &mode_N, &Nmin, &Nstep, &Nrep);

            fscanf(crash_file,
                   "mode_K=%ld\nKmin=%le\nKstep=%le\nKrep=%ld\n",
                   &mode_K, &Kmin, &Kstep, &Krep);

            fscanf(crash_file,
                   "rep=%ld\nseed=%ld\nsave=%ld\nsave_relative=%ld\n",
                   &rep, &seed, &save, &save_relative);

            fscanf(crash_file,
                   "Nfac=%le\nsnap=%ld\nmode_snap=%ld\n",
                   &Nfac, &snap, &mode_snap);

            fscanf(crash_file,
                   "Nsnapmin=%le\nNsnapstep=%le\nNsnaprep=%ld\n",
                   &Nsnapmin, &Nsnapstep, &Nsnaprep);

            fscanf(crash_file, "iN0=%ld\niK0=%ld\nirep0=%ld\n",
                   &iN0, &iK0, &irep0);

            fscanf(crash_file, "N=%le\nK=%le\nNsave=%le\n",
                   &N, &K, &Nsave);

            fclose(crash_file);

            if(save == 1)
               {
                  proto_crash = fopen(".crash", "w");

                  fprintf(proto_crash,
                          "mode_N=%ld\nNmin=%le\nNstep=%le\nNrep=%ld\n",
                          mode_N, Nmin, Nstep, Nrep);

                  fprintf(proto_crash,
                          "mode_K=%ld\nKmin=%le\nKstep=%le\nKrep=%ld\n",
                          mode_K, Kmin, Kstep, Krep);

                  fprintf(proto_crash,
                          "rep=%ld\nseed=%ld\nsave=%ld\n",
                          rep, seed, save);

                  fprintf(proto_crash,
                          "save_relative=%ld\nNfac=%le\nsnap=%ld\n",
                          save_relative, Nfac, snap);

                  fprintf(proto_crash,
                          "mode_snap=%ld\nNsnapmin=%le\n",
                          mode_snap, Nsnapmin);

                  fprintf(proto_crash,
                          "Nsnapstep=%le\nNsnaprep=%ld\n",
                          Nsnapstep, Nsnaprep);

                  fflush(proto_crash);
                  fclose(proto_crash);
               }

            solar_crash(crash_name, output_name); /* finishes crashed */
                                                  /* accretion        */
            ++irep0;
         }

      if(input == 1)                                  /* normal entry */
         {
            input_file = fopen(input_name, "r");

            fscanf(input_file,
                   "mode_N=%ld\nNmin=%le\nNstep=%le\nNrep=%ld\n",
                   &mode_N, &Nmin, &Nstep, &Nrep);

            fscanf(input_file,
                   "mode_K=%ld\nKmin=%le\nKstep=%le\nKrep=%ld\n",
                   &mode_K, &Kmin, &Kstep, &Krep);

            fscanf(input_file,
                   "rep=%ld\nseed=%ld\nsave=%ld\nsave_relative=%ld\n",
                   &rep, &seed, &save, &save_relative);

            fscanf(input_file,
                   "Nfac=%le\nsnap=%ld\nmode_snap=%ld\n",
                   &Nfac, &snap, &mode_snap);

            fscanf(input_file,
                   "Nsnapmin=%le\nNsnapstep=%le\nNsnaprep=%ld\n",
                   &Nsnapmin, &Nsnapstep, &Nsnaprep);

            fclose(input_file);

            iN0 = 0;
            iK0 = 0;
            irep0 = 0;

            if(mode_N == 0)
               {
                  Nrep = 1;
                  Nstep = 0;
               }

            if(mode_K == 0)
               {
                  Krep = 1;
                  Kstep = 0;
               }

            if(mode_snap == 0)
               {
                  Nsnaprep = 1;
                  Nsnapstep = 0;
               }

            if(save == 1)
               {
                  proto_crash = fopen(".crash", "w");

                  fprintf(proto_crash,
                          "mode_N=%ld\nNmin=%le\nNstep=%le\nNrep=%ld\n",
                          mode_N, Nmin, Nstep, Nrep);

                  fprintf(proto_crash,
                          "mode_K=%ld\nKmin=%le\nKstep=%le\nKrep=%ld\n",
                          mode_K, Kmin, Kstep, Krep);

                  fprintf(proto_crash,
                          "rep=%ld\nseed=%ld\nsave=%ld\n",
                          rep, seed, save);

                  fprintf(proto_crash,
                          "save_relative=%ld\nNfac=%le\nsnap=%ld\n",
                          save_relative, Nfac, snap);

                  fprintf(proto_crash,
                          "mode_snap=%ld\nNsnapmin=%le\n",
                          mode_snap, Nsnapmin);

                  fprintf(proto_crash,
                          "Nsnapstep=%le\nNsnaprep=%ld\n",
                          Nsnapstep, Nsnaprep);

                  fflush(proto_crash);
                  fclose(proto_crash);
               }

            if(output == 1)
               {
                  output_file = fopen(output_name, "w");
               }

            else
               {
                  output_file = stdout;
               }

            fprintf(output_file,
                    "mode_N=%ld\nNmin=%le\nNstep=%le\nNrep=%ld\n",
                    mode_N, Nmin, Nstep, Nrep);

            fprintf(output_file,
                    "mode_K=%ld\nKmin=%le\nKstep=%le\nKrep=%ld\n",
                    mode_K, Kmin, Kstep, Krep);

            fprintf(output_file,
                    "rep=%ld\nseed=%ld\nsave=%ld\nsave_relative=%ld\n",
                    rep, seed, save, save_relative);

            fprintf(output_file,
                    "Nfac=%le\nsnap=%ld\nmode_snap=%ld\n",
                    Nfac, snap, mode_snap);

            fprintf(output_file,
                    "Nsnapmin=%le\nNsnapstep=%le\nNsnaprep=%ld\n",
                    Nsnapmin, Nsnapstep, Nsnaprep);

            fflush(output_file);

            if(output == 1)
               {
                  fclose(output_file);
               }
         }

      for(iN = iN0; iN < Nrep; ++iN)        /* loops over repetitions */
         {
            if(mode_N == 0)
               {
                  N = Nmin;
               }

            if(mode_N == 1)
               {
                  N = Nmin + iN * Nstep;
               }
            if(mode_N == 2)
               {
                  N = pow(10, Nmin + iN * Nstep);
               }

            for(iK = iK0; iK < Krep; ++iK)
               {
                  if(mode_K == 0)
                     {
                        K = Kmin;
                     }

                  if(mode_K == 1)
                     {
                        K = Kmin + iK * Kstep;
                     }

                  if(mode_K == 2)
                     {
                        K = pow(10, Kmin + iK * Kstep);
                     }

                  for(irep = irep0; irep < rep; ++irep)
                     {
                        if(save == 1)
                           {
                              if(save_relative == 1)
                                 {
                                    Nsave = Nfac * N;
                                 }

                              else
                                 {
                                    Nsave = Nfac;
                                 }
                           }

                                                    /* the real thing */

                        solar(iN, iK, irep, N, K, &seed, save, Nsave,
                              snap, mode_snap, Nsnapmin, Nsnapstep,
                              Nsnaprep, output_name);
                     }
               }
         }

      if(save == 1)
         {
            unlink("crash.back");
            unlink("crash");
            unlink(".crash");
         }

      exit(EXIT_SUCCESS);
   }
