#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void parser(int argc, char **argv, int *help, int *input,
            char *input_name, int *crash, char *crash_name,
            int *output, char *output_name, int *example,
            char *example_name)

                                               /* parses command line */
                                                         /* ver. 1.01 */
                                                      /* Sep 27, 1999 */
                                                   /* author A. Balaz */
   {
      FILE *input_file, *crash_file, *output_file;
      FILE *example_file, *err;

      err = stderr;

      if(argc == 1)
         {
            *help = 1;
            *input = 0;
            *crash = 0;
            *output = 0;
            *example = 0;
            return;
         }

      if(argc == 2)
         {
            if(strcmp(argv[1], "-h") == 0)
               {
                  *help = 1;
                  *input = 0;
                  *crash = 0;
                  *output = 0;
                  *example = 0;
                  return;
               }

            else
               {
                  fprintf(err, "solar: %s: single option must be -h\n",
                          argv[1]);

                  fflush(err);
                  exit(EXIT_FAILURE);
               }
         }

      if(argc == 3)
         {
            if(strcmp(argv[1], "-i") == 0)
               {
                  *help = 0;
                  *input = 1;
                  *crash = 0;
                  *output = 0;
                  *example = 0;

                  if((input_file = fopen(argv[2], "r")) == NULL)
                     {
                        fprintf(err, "solar: %s: cannot open file\n",
                                argv[2]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }

                  fclose(input_file);
                  strcpy(input_name, argv[2]);
                  return;
               }

            if(strcmp(argv[1], "-c") == 0)
               {
                  *help = 0;
                  *input = 0;
                  *crash = 1;
                  *output = 0;
                  *example = 0;

                  if((crash_file = fopen(argv[2], "rb")) == NULL)
                     {
                        fprintf(err, "solar: %s: cannot open file\n",
                                argv[2]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }

                  fclose(crash_file);
                  strcpy(crash_name, argv[2]);
                  return;
               }

            if(strcmp(argv[1], "-e") == 0)
               {
                  *help = 0;
                  *input = 0;
                  *crash = 0;
                  *output = 0;
                  *example = 1;

                  if((example_file = fopen(argv[2], "w")) == NULL)
                     {
                        fprintf(err, "solar: %s: cannot open file\n",
                                argv[2]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }

                  fclose(example_file);
                  strcpy(example_name, argv[2]);
                  return;
               }

            if(strcmp(argv[1], "-o") == 0)
               {
                  fprintf(err, "solar: -o: -i or -c option missing\n");
                  fflush(err);
                  exit(EXIT_FAILURE);
               }

            if(strcmp(argv[1], "-h") == 0)
               {
                  fprintf(err, "solar: -h: must be single option\n");
                  fflush(err);
                  exit(EXIT_FAILURE);
               }

            fprintf(err, "solar: %s: no such option\n", argv[1]);
            fflush(err);
            exit(EXIT_FAILURE);
         }

      if(argc == 5)
         {
            if(strcmp(argv[1], "-i") == 0)
               {
                  *help = 0;
                  *input = 1;
                  *crash = 0;
                  *output = 1;
                  *example = 0;

                  if((input_file = fopen(argv[2], "r")) == NULL)
                     {
                        fprintf(err, "solar: %s: cannot open file\n",
                                argv[2]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }

                  if(strcmp(argv[3], "-o") == 0)
                     {
                        if((output_file = fopen(argv[4], "w")) == NULL)
                           {
                              fprintf(err,
                                      "solar: %s: cannot open file\n",
                                      argv[4]);

                              fflush(err);
                              exit(EXIT_FAILURE);
                           }

                        fclose(input_file);
                        fclose(output_file);
                        strcpy(input_name, argv[2]);
                        strcpy(output_name, argv[4]);
                        return;
                     }

                  else
                     {
                        fprintf(err, "solar: %s: must be -o\n",
                                argv[3]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }
               }

            if(strcmp(argv[1], "-c") == 0)
               {
                  *help = 0;
                  *input = 0;
                  *crash = 1;
                  *output = 1;
                  *example = 0;

                  if((crash_file = fopen(argv[2], "rb")) == NULL)
                     {
                        fprintf(err, "solar: %s: cannot open file\n",
                                argv[2]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }

                  if(strcmp(argv[3], "-o") == 0)
                     {
                        if((output_file = fopen(argv[4], "a+")) == NULL)
                           {
                              fprintf(err,
                                      "solar: %s: cannot open file\n",
                                      argv[4]);

                              fflush(err);
                              exit(EXIT_FAILURE);
                           }

                        fclose(crash_file);
                        fclose(output_file);
                        strcpy(crash_name, argv[2]);
                        strcpy(output_name, argv[4]);
                        return;
                     }

                  else
                     {
                        fprintf(err, "solar: %s: must be -o\n",
                                argv[3]);

                        fflush(err);
                        exit(EXIT_FAILURE);
                     }
               }

            if(strcmp(argv[1], "-o") == 0)
               {
                  *help = 0;
                  *output = 1;
                  *example = 0;

                  if(strcmp(argv[3], "-i") == 0)
                     {
                        *input = 1;
                        *crash = 0;

                        if((input_file = fopen(argv[4], "r")) == NULL)
                           {
                              fprintf(err,
                                      "solar: %s: cannot open file\n",
                                      argv[4]);

                              fflush(err);
                              exit(EXIT_FAILURE);
                           }

                        if((output_file = fopen(argv[2], "w")) == NULL)
                           {
                              fprintf(err,
                                      "solar: %s: cannot open file\n",
                                      argv[2]);

                              fflush(err);
                              exit(EXIT_FAILURE);
                           }

                        fclose(input_file);
                        fclose(output_file);
                        strcpy(input_name, argv[4]);
                        strcpy(output_name, argv[2]);
                        return;
                     }

                  if(strcmp(argv[3], "-c") == 0)
                     {
                        *input = 0;
                        *crash = 1;

                        if((crash_file = fopen(argv[4], "rb")) == NULL)
                           {
                              fprintf(err,
                                      "solar: %s: cannot open file\n",
                                      argv[4]);

                              fflush(err);
                              exit(EXIT_FAILURE);
                           }

                        if((output_file = fopen(argv[2], "a+")) == NULL)
                           {
                              fprintf(err,
                                      "solar: %s: cannot open file\n",
                                      argv[2]);

                              fflush(err);
                              exit(EXIT_FAILURE);
                           }

                        fclose(crash_file);
                        fclose(output_file);
                        strcpy(crash_name, argv[4]);
                        strcpy(output_name, argv[2]);
                        return;
                     }

                  fprintf(err, "solar: %s: must be -i or -c\n",
                          argv[3]);

                  fflush(err);
                  exit(EXIT_FAILURE);
               }

            if(strcmp(argv[1], "-h") == 0)
               {
                  fprintf(err, "solar: -h: must be single option\n");
                  fflush(err);
                  exit(EXIT_FAILURE);
               }

            if(strcmp(argv[1], "-e") == 0)
               {
                  fprintf(err, "solar: -e: too many arguments\n");
                  fflush(err);
                  exit(EXIT_FAILURE);
               }

            fprintf(err, "solar: %s: no such option\n", argv[1]);
            fflush(err);
            exit(EXIT_FAILURE);
         }

      if((argc == 4) || (argc > 5))
         {
            fprintf(err, "solar: wrong number of arguments\n");
            fflush(err);
            exit(EXIT_FAILURE);
         }
   }

void print_help(void)

                                                       /* prints help */
                                                         /* ver. 1.01 */
                                                      /* Sep 27, 1999 */
                                                   /* author A. Balaz */
   {
      fprintf(stdout, "\n");
      fprintf(stdout, "SYNOPSIS\n");
      fprintf(stdout, "  solar [ -i input [ -o out ] | -c crash ");
      fprintf(stdout, "  [ -o out ] | -e example | -h ]\n\n");
      fprintf(stdout, "DESCRIPTION\n");
      fprintf(stdout, "  solar is a simulation of planetary ");
      fprintf(stdout, "formation trough gravitational\n");
      fprintf(stdout, "  accretion. It is based on a simple ");
      fprintf(stdout, "interaction criterion, depending\n");
      fprintf(stdout, "  on a single parameter K. The second basic ");
      fprintf(stdout, "quantity is N, initial\n");
      fprintf(stdout, "  number of dust particles. Output consists ");
      fprintf(stdout, "of radii, masses and spins\n");
      fprintf(stdout, "  of n final particles (planets).\n\n");
      fprintf(stdout, "  The following command line options are ");
      fprintf(stdout, "allowed:\n\n");
      fprintf(stdout, "     -i input      Read input parameters ");
      fprintf(stdout, "from the file 'input'. If -o\n");
      fprintf(stdout, "                   option is present, output ");
      fprintf(stdout, "is stored in the file 'out',\n");
      fprintf(stdout, "                   otherwise it is sent on ");
      fprintf(stdout, "stdout.\n\n");
      fprintf(stdout, "     -c crash      If the simulation has been ");
      fprintf(stdout, "killed, it can be continued\n");
      fprintf(stdout, "                   using this option. Input ");
      fprintf(stdout, "parameters are read from the\n");
      fprintf(stdout, "                   file 'crash'. If -o ");
      fprintf(stdout, "option is present, the output is\n");
      fprintf(stdout, "                   stored in the file 'out', ");
      fprintf(stdout, "otherwise it is sent on\n");
      fprintf(stdout, "                   stdout.\n\n");
      fprintf(stdout, "     -e example    Create the file 'example', ");
      fprintf(stdout, "the example of an input\n");
      fprintf(stdout, "                   file.\n\n");
      fprintf(stdout, "     -h            Print this page.\n\n");
      fprintf(stdout, "EXAMPLES\n");
      fprintf(stdout, "Create the example of an input file:\n\tsolar -e myinput\n\n");
      fprintf(stdout, "We suggest you to read the file myinput and change it to suit your needs.\nIt ");
      fprintf(stdout, "contains a detail explanation of all parameters.\n\n");
      fprintf(stdout, "Start the program using the input file myinput and send the output ");
      fprintf(stdout, "to the\nfile myout:\n\tsolar -i myinput -o myout\n\n");
      fprintf(stdout, "Output file myout contains the explanation of the data in it.\n\n");
      fprintf(stdout, "Continue the execution after the crash (if this feature is turned on in the\n");
      fprintf(stdout, "input file) and send the output to the file myout:\nsolar -c crash -o myout\n\n");
      fflush(stdout);
      return;
   }

void create_example(char *example_name)

                                     /* creates example of input file */
                                                         /* ver. 1.01 */
                                                      /* Sep 27, 1999 */
                                                   /* author A. Balaz */
   {
      FILE *exmpl;

      exmpl = fopen(example_name, "w");

      fprintf(exmpl, "mode_N=%ld\nNmin=%le\nNstep=%le\nNrep=%ld\n",
              2, 3e0, 1e0, 3);

      fprintf(exmpl, "mode_K=%ld\nKmin=%le\nKstep=%le\nKrep=%ld\n",
              1, 1e-3, 1e-3, 2);

      fprintf(exmpl, "rep=%ld\nseed=%ld\nsave=%ld\nsave_relative=%ld\n",
              2, 2712973, 0, 1);

      fprintf(exmpl, "Nfac=%le\nsnap=%ld\nmode_snap=%ld\n", 1e-1, 0, 2);

      fprintf(exmpl, "Nsnapmin=%le\nNsnapstep=%le\nNsnaprep=%ld\n",
              4e0, 1e0, 0);
              
      fprintf(exmpl, "****************************************");
      fprintf(exmpl, "***********************************\n");
      fprintf(exmpl, "Text above is the example of an input file. ");
      fprintf(exmpl, "You can modify it.\n\n");
      fprintf(exmpl, "If mode_N = 0, N has only single value\n");
      fprintf(exmpl, "      N = Nmin.\n\n");
      fprintf(exmpl, "If mode_N = 1, N has Nrep values\n");
      fprintf(exmpl, "      N = Nmin + i * Nstep, i = 0, 1, ..., ");
      fprintf(exmpl, "Nrep - 1.\n\n");
      fprintf(exmpl, "If mode_N = 2, N has Nrep values\n");
      fprintf(exmpl, "      log N = Nmin + i * Nstep, i = 0, 1, ");
      fprintf(exmpl, "..., Nrep -1.\n\n");
      fprintf(exmpl, "If mode_K = 0, K has only single value\n");
      fprintf(exmpl, "      K = Kmin.\n\n");
      fprintf(exmpl, "If mode_K = 1, K has Krep values\n");
      fprintf(exmpl, "      K = Kmin + i * Kstep, i = 0, 1, ..., ");
      fprintf(exmpl, "Krep - 1.\n\n");
      fprintf(exmpl, "If mode_K = 2, K has Krep values\n");
      fprintf(exmpl, "      log K = Kmin + i * Kstep, i = 0, 1, ");
      fprintf(exmpl, "..., Krep -1.\n\n");
      fprintf(exmpl, "rep is the number of repetitions for the ");
      fprintf(exmpl, "fixed values of N and K.\n\n");
      fprintf(exmpl, "seed is the initialisation for the random ");
      fprintf(exmpl, "number generator.\n\n");
      fprintf(exmpl, "If save = 1, the crash file 'crash' will ");
      fprintf(exmpl, "be created every\n");
      fprintf(exmpl, "Nsave dust particles are added. If ");
      fprintf(exmpl, "save_relative = 1,\n");
      fprintf(exmpl, "Nsave = Nfac * N, otherwise Nsave = ");
      fprintf(exmpl, "Nfac.\n\n");
      fprintf(exmpl, "If snap = 1, the snapshot files will be ");
      fprintf(exmpl, "created when the number\n");
      fprintf(exmpl, "of added particles i satisfy i = Nsnap, ");
      fprintf(exmpl, "where Nsnap\n\n");
      fprintf(exmpl, "   for mode_snap = 0 has a single value\n");
      fprintf(exmpl, "         Nsnap = Nsnapmin,\n\n");
      fprintf(exmpl, "   for mode_snap = 1 has Nsnaprep - 1 values\n");
      fprintf(exmpl, "         Nsnap = Nsnapmin + i * Nsnapstep, ");
      fprintf(exmpl, "i = 0, 1, ..., Nsnaprep - 1,\n\n");
      fprintf(exmpl, "   for mode_snap = 2 has Nsnaprep - 1 values\n");
      fprintf(exmpl, "         log Nsnap = Nsnapmin + i * ");
      fprintf(exmpl, "Nsnapstep, i = 0, 1, ..., Nsnaprep - 1.\n\n");
      fprintf(exmpl, "Nsnaprep = 0 in the input file means ");
      fprintf(exmpl, "Nsnaprep = infinity.\n");
      fflush(exmpl);
      fclose(exmpl);
   }
